//
//  MFi_SPPViewController.m
//  MFi_SPP
//
//  Created by James Chen on 12/2/10.
//  Copyright 2010 viWave. All rights reserved.
//

#import "MFi_SPPViewController.h"

NSString *const MFi_SPP_Protocol = @"com.issc.datapath";

@interface MFi_SPPMessage : NSObject
{
	NSString *string;
	BOOL fromRemote;
}

@property (nonatomic, retain) NSString *string;
@property(nonatomic) BOOL fromRemote;
@end

@implementation MFi_SPPMessage
@synthesize string;
@synthesize fromRemote;
+ (MFi_SPPMessage *)createMessage:(NSString *)string fromRemote:(BOOL)fromRemote {
	MFi_SPPMessage *newMessage = [MFi_SPPMessage new];
	newMessage.string = string;
	newMessage.fromRemote = fromRemote;
	return [newMessage autorelease];
}
@end

@interface MFi_SPPViewController(viPrivate)
- (void)stopDataSession:(id)sender;
- (void)setSession:(EASession*)newSession;
@end


@implementation MFi_SPPViewController
@synthesize inputTextField;
@synthesize remoteLabel;
@synthesize statusLabel;
@synthesize accessory;

- (id)initWithCoder:(NSCoder *)aDecoder {
    NSLog(@"initWithCoder");
	if (self == [super initWithCoder:aDecoder]) {
		_datas = [NSMutableArray new];
	}
	return self;
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    NSLog(@"viewDidLoad");
    [super viewDidLoad];
	self.remoteLabel.text = accessory.name;
    
    content = [[NSMutableString alloc] initWithCapacity:500008];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)viewDidUnload {
    self.remoteLabel = nil;
	self.inputTextField = nil;
    self.statusLabel = nil;
}

- (void)dealloc {
	[self stopDataSession:self];
	[session release];
	[accessory release];
	[_outgoingData release];
 	[_datas release];
    [content release];
	[[NSNotificationCenter defaultCenter] removeObserver:self name:nil object:nil];
    [super dealloc];
}

- (void)stopDataSession:(id)sender {
    NSLog(@"stopDataSession");
	[self setSession:NULL];
}
- (void)writeDataToOutputStream {
    NSLog(@"writeDataToOutputStream");
    if ([_outgoingData length] > 0 ) {
        //        NSLog(@"writeDataOutputStream length>0");
        
        NSInteger bytesWritten = [[session outputStream] write:(const uint8_t *)[_outgoingData bytes]
													 maxLength:[_outgoingData length]];
        [_outgoingData release];
        _outgoingData = NULL;
	}
}

- (void)sendData:(id)sender {
    NSLog(@"sendData");
	NSString *rawString = nil;
    NSString *rawString2 = @"\n";
	UITextField *temp = (UITextField *)sender;
    rawString = temp.text;
    rawString = [temp.text stringByAppendingString:@"\n\n\n"];
    [_datas addObject:[MFi_SPPMessage createMessage:rawString fromRemote:NO]];
	if ([[session outputStream] hasSpaceAvailable]) {
		[_outgoingData release];
        _outgoingData = [[rawString  dataUsingEncoding:NSMacOSRomanStringEncoding] retain];
        [self writeDataToOutputStream];
    }
	temp.text = @"";
}

- (void)printbarcode:(id)sender {
    Byte byte[] = {29,72,2,29,104,100,29,107,73,10,123,66,78,111,46,123,67,12,34,56};
    
    if ([[session outputStream] hasSpaceAvailable]) {
		[_outgoingData release];
        _outgoingData = [[NSMutableData dataWithBytes:byte length:20] retain];
        NSString *rawString3 = @"\n\n";
        NSData *ndata = [[rawString3  dataUsingEncoding:NSMacOSRomanStringEncoding] retain];
        [_outgoingData appendData:ndata];
		[self writeDataToOutputStream];
	}
}

- (void)print2dcode:(id)sender{
    Byte byte[] = {0x1D ,0x5A ,0x02 ,0x1B ,0x5A ,0x03 ,0x4C ,0x06 ,0x05 ,0x00 ,0x02 ,0x01 ,0x01 ,0x0D ,0x0A};
    
    if ([[session outputStream] hasSpaceAvailable]) {
		[_outgoingData release];
        _outgoingData = [[NSMutableData dataWithBytes:byte length:15] retain];
        NSString *rawString3 = @"\n\n";
        NSData *ndata = [[rawString3  dataUsingEncoding:NSMacOSRomanStringEncoding] retain];
        [_outgoingData appendData:ndata];
		[self writeDataToOutputStream];
	}
}

- (void)printtable:(id)sender {
    Byte byte[] = {0x1b,0x21,32};
    Byte byte1[] = {0x1b,0x21,0};
    NSString *rawString = @"     Tom's Store \n\n";
    NSString *rawString2 = @"    DESCRIPTION     PRICE  QTY   AMOUNT\n    -----------------------------------\n    Book            1.50   1     1.50  \n    Shoe            9.08   1     9.80  \n    Pen             0.85   1     0.85  \n    -----------------------------------\n    TOTAL  QTY:3   TOTAL  SALE:12.15   \n    PAID:15.00     CHANGE  DUE:2.85    \n         Welcome to our shop!          \n          Tel:0876-67835632            \n\n\n";

     NSString *rawString3 = @"\n\n";

    NSData *ndata = [[rawString  dataUsingEncoding:NSMacOSRomanStringEncoding] retain];
    NSData *ndata1 = [[rawString2  dataUsingEncoding:NSMacOSRomanStringEncoding] retain];
    NSData *ndata2 = [[rawString3  dataUsingEncoding:NSMacOSRomanStringEncoding] retain];
    _outgoingData = [[NSMutableData alloc]init];
    [_outgoingData appendBytes:byte length:3];
    [_outgoingData appendData:ndata];
    [_outgoingData appendBytes:byte1 length:3];
     [_outgoingData appendData:ndata1];
    NSInteger bytesWritten = [[session outputStream] write:(const uint8_t *)[_outgoingData bytes]
                                                 maxLength:[_outgoingData length]];
    [_outgoingData release];
    _outgoingData = NULL;
    
}

- (void)printimg:(id)sender {
    NSLog(@"printimg");
    NSString *myFilePath = [[NSBundle mainBundle]
                            pathForResource:@"goodwork"
                            ofType:@"bmp"];
    
    
    UIImage *newImage = nil;
    newImage = [UIImage imageWithContentsOfFile:myFilePath];
    
    unsigned char *ucTest = nil;
    /////////////////////////////////
    CGImageRef imageref = [newImage CGImage];
    CGColorSpaceRef colorspace=CGColorSpaceCreateDeviceRGB();
    
    int width=CGImageGetWidth(imageref);
    int height=CGImageGetHeight(imageref);
    int bytesPerPixel=4;
    int bytesPerRow=bytesPerPixel*width;
    int bitsPerComponent = 8;
    int intPointValue = 0;
    int s = 0;
    unsigned char * imagedata=malloc(width*height*bytesPerPixel);
    
    Byte * printdata=malloc((width / 8 + 4) * height);
    
    CGContextRef cgcnt = CGBitmapContextCreate(imagedata,
                                               width,
                                               height,
                                               bitsPerComponent,
                                               bytesPerRow,
                                               colorspace,
                                               kCGImageAlphaPremultipliedFirst);
    //将图像写入一个矩形
    CGRect therect = CGRectMake(0, 0, width, height);
    CGContextDrawImage(cgcnt, therect, imageref);
    
    Byte *bitbuf = malloc(width / 8);
    
    int intPix = 0;
    
    int p0=0, p1=0, p2=0, p3=0, p4=0, p5=0, p6=0, p7=0;
    for (int i = 0; i < height; i++) {
        for (int k = 0; k < width / 8 ; k++) {
            intPix = i * width * 4 + k * 8 * 4 + 1;
            intPointValue = imagedata[intPix];
            
            if (intPointValue == 255)
                p0 = 0;
            else {
                p0 = 1;
            }
            
            intPix = intPix + 4;
            intPointValue = imagedata[intPix];
            if (intPointValue == 255)
                p1 = 0;
            else {
                p1 = 1;
            }
            intPix = intPix + 4;
            intPointValue = imagedata[intPix];
            if (intPointValue == 255)
                p2 = 0;
            else {
                p2 = 1;
            }
            intPix = intPix + 4;
            intPointValue = imagedata[intPix];
            if (intPointValue == 255)
                p3 = 0;
            else {
                p3 = 1;
            }
            intPix = intPix + 4;
            intPointValue = imagedata[intPix];
            if (intPointValue == 255)
                p4 = 0;
            else {
                p4 = 1;
            }
            intPix = intPix + 4;
            intPointValue = imagedata[intPix];
            if (intPointValue == 255)
                p5 = 0;
            else {
                p5 = 1;
            }
            intPix = intPix + 4;
            intPointValue = imagedata[intPix];
            if (intPointValue == 255)
                p6 = 0;
            else {
                p6 = 1;
            }
            intPix = intPix + 4;
            intPointValue = imagedata[intPix];
            if (intPointValue == 255)
                p7 = 0;
            else {
                p7 = 1;
            }
            
            int value = p0 * 128 + p1 * 64 + p2 * 32 + p3 * 16 + p4 * 8
            + p5 * 4 + p6 * 2 + p7;
            bitbuf[k] = (Byte) value;
        }
        
        if (i!= 0)
            s += 1;
        
        printdata[s] = (Byte) 0x16;
        //        NSLog(@"%X",printdata[s]);
        s += 1;
        printdata[s] = (Byte) (width / 8);
        //        if (printdata[s] < 16) {
        //            NSLog(@"0%X",printdata[s]);
        //        }
        //        else
        //            NSLog(@"%X",printdata[s]);
        for (int t = 0; t < width / 8; t++) {
            s += 1;
            printdata[s] = bitbuf[t];
            //            if (printdata[s] < 16) {
            //                NSLog(@"0%X",printdata[s]);
            //            }
            //            else
            //                NSLog(@"%X",printdata[s]);
        }
        s += 1;
        printdata[s] = (Byte) 0x15;
        //NSLog(@"%X",printdata[s]);
        s += 1;
        printdata[s] = (Byte) 0x01;
        //NSLog(@"01");
    }
    
    if ([[session outputStream] hasSpaceAvailable]) {
		[_outgoingData release];
		//_outgoingData = [NSMutableData dataWithBytes:printdata length:(width / 8 + 4) * height];
        _outgoingData = [[NSMutableData dataWithBytes:printdata length:(width / 8 + 4) * height] retain];
        
        NSString *rawString3 = @"\n\n";
        NSData *ndata = [[rawString3  dataUsingEncoding:NSMacOSRomanStringEncoding] retain];
        [_outgoingData appendData:ndata];

		[self writeDataToOutputStream];
	}
    
}


- (void)setSession:(EASession*)newSession {
    NSLog(@"setSession");
	[[session inputStream] close];
	[[session inputStream] removeFromRunLoop:[NSRunLoop currentRunLoop]
									 forMode:NSDefaultRunLoopMode];
	[[session outputStream] close];
	[[session outputStream] removeFromRunLoop:[NSRunLoop currentRunLoop]
									  forMode:NSDefaultRunLoopMode];
	[session release];
	session = [newSession retain];
    
	if (session) {
		[[session inputStream] setDelegate:self];
		[[session inputStream] scheduleInRunLoop:[NSRunLoop currentRunLoop]
										 forMode:NSDefaultRunLoopMode];
		[[session inputStream] open];
		[[session outputStream] setDelegate:self];
		[[session outputStream] scheduleInRunLoop:[NSRunLoop currentRunLoop]
										  forMode:NSDefaultRunLoopMode];
		[[session outputStream] open];
	}
}
- (void)stream:(NSStream *)stream handleEvent:(NSStreamEvent)streamEvent
{
    NSLog(@"stream");
	switch (streamEvent) {
        case NSStreamEventHasBytesAvailable:
            // Process the incoming stream data.
        {
            static uint8_t buf[1024];
            unsigned int len = 0;
            len = [(NSInputStream *)stream read:buf maxLength:1024];
            if (len) {
                buf[len] = 0;
                NSString *ReceiveStr = [NSString stringWithCString:(const char *)buf encoding:NSMacOSRomanStringEncoding];
                
                [content appendString:ReceiveStr];
                [_datas addObject:[MFi_SPPMessage createMessage: ReceiveStr fromRemote:YES]];
                
            } else {
                NSLog(@"no buffer!");
            }
        }
            break;
			
        default:
            break;
    }
}
- (void)setAccessory:(EAAccessory*)newAccessory {
    NSLog(@"setAccessory");
	if (newAccessory != accessory) {
		[accessory setDelegate:NULL];
		[self setSession:NULL];
		[accessory release];
		accessory = [newAccessory retain];
		[accessory setDelegate:self];
		self.navigationItem.title = accessory.name;
		self.remoteLabel.text = accessory.name;
		if (accessory) {
			EASession *newSession = [[EASession alloc] initWithAccessory:accessory
															 forProtocol:MFi_SPP_Protocol];
			[self setSession:newSession];
			[newSession release];
            statusLabel.textColor = [UIColor greenColor];
			statusLabel.text = @"Connected";
			
		} else {
			statusLabel.text = @"Disconnected";
            statusLabel.textColor = [UIColor redColor];

        }
	}
}
- (void)accessoryDidDisconnect:(EAAccessory *)theAccessory {
    NSLog(@"accessoryDidDisconnect");
	if (theAccessory == accessory) {
		[self setAccessory:NULL];
	}
}
- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    NSLog(@"textFieldShouldReturn");
    inputTextField.placeholder = @"";
    [inputTextField resignFirstResponder];
    [self sendData:textField];
    inputTextField.text = @"";
	return YES;
}
- (BOOL) textFieldDidBeginEditing: (UITextField *)textField
{
    NSLog(@"textFieldDidBeginEditing");
    if (textField == inputTextField) {
        inputTextField.keyboardType = UIKeyboardTypeASCIICapable;
        inputTextField.placeholder = @"";
        inputTextField.returnKeyType = UIReturnKeySend;
    }
    
    return YES;
}


@end
